from time import time

class SearchHistory:

    def __init__(self,filename,vfs):
        self.vfs = vfs
        self.filename = filename
        self.history = self.vfs.get_json_as_obj(self.filename)

    def get(self):
        return {k: self.history[k] for k in list(self.history)}

    def add(self, query):
        for k, v in list(self.history.items()):
            if v["query"] == query:
                return

        self.history[str(int(time()))] = {"query": query}
        self._save()

    def remove(self, query):
        self.history = {k: v for k, v in list(self.history.items()) if v["query"] != query}
        self._save()

    def clear(self):
        return self.vfs.delete(self.filename)

    def _save(self):
        return self.vfs.save_obj_to_json(self.filename, self.history)

